Bug 1764607 (CVE-2019-0210) - CVE-2019-0210 thrift: Out-of-bounds read related to TJSONProtocol or TSimpleJSONProtocol
Summary: CVE-2019-0210 thrift: Out-of-bounds read related to TJSONProtocol or TSimpleJ...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2019-0210
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1764609 1764608
Blocks: 1764610
TreeView+ depends on / blocked
 
Reported: 2019-10-23 13:05 UTC by Pedro Sampaio
Modified: 2021-12-14 04:40 UTC (History)
76 users (show)

Fixed In Version: thrift 0.13.0
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-03-12 22:31:42 UTC


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:0804 0 None None None 2020-03-12 17:04:26 UTC
Red Hat Product Errata RHSA-2020:0805 0 None None None 2020-03-12 17:05:49 UTC
Red Hat Product Errata RHSA-2020:0806 0 None None None 2020-03-12 17:01:32 UTC
Red Hat Product Errata RHSA-2020:0811 0 None None None 2020-03-12 17:00:33 UTC
Red Hat Product Errata RHSA-2020:0951 0 None None None 2020-03-23 20:13:46 UTC
Red Hat Product Errata RHSA-2020:0961 0 None None None 2020-03-24 11:13:43 UTC
Red Hat Product Errata RHSA-2020:0962 0 None None None 2020-03-24 11:38:41 UTC
Red Hat Product Errata RHSA-2020:2067 0 None None None 2020-05-18 10:27:04 UTC
Red Hat Product Errata RHSA-2020:2321 0 None None None 2020-05-26 16:09:52 UTC
Red Hat Product Errata RHSA-2020:2333 0 None None None 2020-05-28 15:59:23 UTC
Red Hat Product Errata RHSA-2020:2511 0 None None None 2020-06-10 19:05:42 UTC
Red Hat Product Errata RHSA-2020:2512 0 None None None 2020-06-11 07:17:00 UTC
Red Hat Product Errata RHSA-2020:2513 0 None None None 2020-06-11 07:08:35 UTC
Red Hat Product Errata RHSA-2020:2515 0 None None None 2020-06-10 19:23:59 UTC
Red Hat Product Errata RHSA-2020:5568 0 None None None 2020-12-16 12:12:26 UTC

Description Pedro Sampaio 2019-10-23 13:05:45 UTC
A flaw was found in Apache Thrift versions 0.9.3 to 0.12.0. A server implemented in Go using TJSONProtocol or TSimpleJSONProtocol may panic when feed with invalid input data.

References:

https://seclists.org/oss-sec/2019/q4/29

Comment 1 Pedro Sampaio 2019-10-23 13:06:05 UTC
Created thrift tracking bugs for this issue:

Affects: epel-7 [bug 1764609]
Affects: fedora-all [bug 1764608]

Comment 2 Anten Skrabec 2019-11-04 05:04:56 UTC
RHOSP: thrift is shipped in ODL which is java based, not golang which is required for this flaw.

Comment 5 Paramvir jindal 2019-11-19 16:23:49 UTC
libthrift version shipped with RHSSO 7.3.4 is :

rhsso-7.3.4/modules/system/layers/base/org/apache/thrift/main/libthrift-0.11.0.redhat-00006.jar which seems to be affected.

Also I am unable to locate the affected class (TJSONProtocol or TSimpleJSONProtocol) in jaeger-thrift-0.30.6.redhat-00001.jar (shipped with RHSSO 7.3.4) so I am marking RHSSO component jaeger-thrift as not affected.

Comment 11 Kunjan Rathod 2019-12-07 00:11:30 UTC
This vulnerability is out of security support scope for the following products:

 * Red Hat JBoss Operations Network 3
 * Red Hat JBoss Fuse Service Works 6
 * Red Hat JBoss Data Virtualization & Services 6

Please refer to https://access.redhat.com/support/policy/updates/jboss_notes for more details.

Comment 15 Sam Fowler 2020-01-14 04:28:57 UTC
There's only a single commit between v0.12.0 and v0.13.0 that touches the Go JSONProtocol implementation, which therefore must be the patch:


$ git log v0.12.0..v0.13.0 -- lib/go/thrift/simple_json_protocol.go
commit 264a3f318ed3e9e51573f67f963c8509786bcec2
Author: Jens Geyer <jensg>
Date:   Sat Feb 23 13:11:40 2019 +0100

    additional test for TSimpleJSONProtocol

diff --git a/lib/go/thrift/simple_json_protocol.go b/lib/go/thrift/simple_json_protocol.go
index 2e8a7111..f5e0c05d 100644
--- a/lib/go/thrift/simple_json_protocol.go
+++ b/lib/go/thrift/simple_json_protocol.go
@@ -60,7 +60,7 @@ func (p _ParseContext) String() string {
        return "UNKNOWN-PARSE-CONTEXT"
 }
 
-// JSON protocol implementation for thrift.
+// Simple JSON protocol implementation for thrift.
 //
 // This protocol produces/consumes a simple output format
 // suitable for parsing by scripting languages.  It should not be
@@ -1316,7 +1316,7 @@ func (p *TSimpleJSONProtocol) readNumeric() (Numeric, error) {
 func (p *TSimpleJSONProtocol) safePeekContains(b []byte) bool {
        for i := 0; i < len(b); i++ {
                a, _ := p.reader.Peek(i + 1)
-               if len(a) == 0 || a[i] != b[i] {
+               if len(a) < (i+1) || a[i] != b[i] {
                        return false
                }
        }


The modified function, safePeekContains(), is not present in 0.9.2, which is consistent with the upstream announcement stating that versions 0.9.3 through 0.12.0 are affected.

Comment 18 Sam Fowler 2020-01-14 04:30:34 UTC
Statement:

Red Hat OpenStack Platform ships OpenDaylight, which contains a vulnerable version of libthrift. However, OpenDaylight is not affected as this is a Golang specific problem, lowering the impact of the vulnerability for OpenDaylight. As such, Red Hat will not be providing a fix for OpenDaylight at this time.

The version of thrift delivered in OpenShift Container Platform is not affected by this vulnerability as it does not contain the affected code.

Comment 19 errata-xmlrpc 2020-03-12 17:00:29 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:0811 https://access.redhat.com/errata/RHSA-2020:0811

Comment 20 errata-xmlrpc 2020-03-12 17:01:28 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2020:0806 https://access.redhat.com/errata/RHSA-2020:0806

Comment 21 errata-xmlrpc 2020-03-12 17:04:22 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2020:0804 https://access.redhat.com/errata/RHSA-2020:0804

Comment 22 errata-xmlrpc 2020-03-12 17:05:46 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2020:0805 https://access.redhat.com/errata/RHSA-2020:0805

Comment 23 Product Security DevOps Team 2020-03-12 22:31:42 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2019-0210

Comment 25 errata-xmlrpc 2020-03-23 20:13:42 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On

Via RHSA-2020:0951 https://access.redhat.com/errata/RHSA-2020:0951

Comment 26 errata-xmlrpc 2020-03-24 11:13:33 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:0961 https://access.redhat.com/errata/RHSA-2020:0961

Comment 27 errata-xmlrpc 2020-03-24 11:38:36 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 7
  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 6
  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 8

Via RHSA-2020:0962 https://access.redhat.com/errata/RHSA-2020:0962

Comment 29 errata-xmlrpc 2020-05-18 10:26:53 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2020:2067 https://access.redhat.com/errata/RHSA-2020:2067

Comment 30 errata-xmlrpc 2020-05-26 16:09:48 UTC
This issue has been addressed in the following products:

  Red Hat Data Grid 7.3.6

Via RHSA-2020:2321 https://access.redhat.com/errata/RHSA-2020:2321

Comment 31 errata-xmlrpc 2020-05-28 15:59:19 UTC
This issue has been addressed in the following products:

  EAP-CD 19 Tech Preview

Via RHSA-2020:2333 https://access.redhat.com/errata/RHSA-2020:2333

Comment 32 errata-xmlrpc 2020-06-10 19:05:39 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 6

Via RHSA-2020:2511 https://access.redhat.com/errata/RHSA-2020:2511

Comment 33 errata-xmlrpc 2020-06-10 19:23:55 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:2515 https://access.redhat.com/errata/RHSA-2020:2515

Comment 34 errata-xmlrpc 2020-06-11 07:08:31 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 8

Via RHSA-2020:2513 https://access.redhat.com/errata/RHSA-2020:2513

Comment 35 errata-xmlrpc 2020-06-11 07:16:56 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.3 for RHEL 7

Via RHSA-2020:2512 https://access.redhat.com/errata/RHSA-2020:2512

Comment 37 errata-xmlrpc 2020-12-16 12:12:20 UTC
This issue has been addressed in the following products:

  Red Hat Fuse 7.8.0

Via RHSA-2020:5568 https://access.redhat.com/errata/RHSA-2020:5568


Note You need to log in before you can comment on or make changes to this bug.